
#pragma hdrstop
#include <condefs.h>
#include <stdio.h>
#include <mem.h>
#include <alloc.h>
#include <string.h>

#include "d88.h"
//---------------------------------------------------------------------------
USEUNIT("d88.cpp");
//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char **argv)
{
	FILE			*out;
	D88 disk;
	unsigned char	*buf_dir;
	unsigned char	*buf_data;
	unsigned int	pos = 0x20;
	unsigned int	filepos = 0;
	unsigned int	filecount = 1;

	printf( "MAKO-DOS File Extractor 070111 (c)Fac.KUROHANE\n" );

	if( argc < 2 )
	{
		printf( "Usage: MAKOREAD <filename.d88>\n" );
		return 0;
	}

	buf_data = ( unsigned char * )calloc( 1, 0x1F4000 );
	if( buf_data == NULL )
	{
		printf( "error: Can't allocate memory\n" );
		return 0;
	}

	buf_dir = ( unsigned char * )calloc( 1, 0x400 * 5 );
	if( buf_dir == NULL )
	{
		printf( "error: Can't allocate memory\n" );
		free( buf_data );
		return 0;
	}
	if( !disk.SetFile( argv[1] ))
	{
		printf( "error: Can't open %s\n", argv[1] );
		free( buf_data );
		free( buf_dir );
		return 0;
	}

	printf( "\n" );

	disk.SelectDisk( 0 );
	disk.SetRecordRange( 1, 9 );	//9ZN^FD

	//fBNgGg
	disk.ReadDATA( 0, 0, 0, 5, 3, buf_dir, 0x400 * 5 );
//--
//out = fopen( "dir.dat", "wb" );
//fwrite( buf_dir, 0x400 * 5, 1, out );
//fclose( out );
//--
	if( memcmp( buf_dir, "MAKO-DOS", 8 ))
	{
		printf( "error: not MAKO-DOS format\n" );
		free( buf_data );
		free( buf_dir );
		return 0;
	}

	//f[^
	disk.ReadDATA( 1, 0, 1, 1, 3, buf_data, 0x400 * 9 * 153 );

//--
//out = fopen( "data.dat", "wb" );
//fwrite( buf_data, 0x1F4000, 1, out );
//fclose( out );
//--

	while( buf_dir[pos] != 0xFF )
	{
		unsigned int	count = 0;
		unsigned int	filesize = 0;
		char			filename_base[8+1];
		char			ext[3+1];
		char			filename[13+1];
		bool			extract = true;

		memset( filename_base, 0, sizeof( filename_base ));
		memset( ext, 0, sizeof( ext ));
		memset( filename, 0, sizeof( filename ));

		//t@Cl[
		for( int i = 0, count = 0; i != 8; i++ )
		{
			if( buf_dir[pos + i] != 0x20 )
			{
				filename_base[count] = buf_dir[pos + i];
				count++;
			}
		}

		//gq
		for( int i = 8,count = 0; i != 11; i++ )
		{
			if( buf_dir[pos + i] != 0x20 )
			{
				ext[count] = buf_dir[pos + i];
				count++;
			}
		}

		sprintf( filename, "%s.%s", filename_base, ext );

		if( argc > 2 && ( strcmpi( ext, argv[2] ) != 0 )) extract = false;

		filesize  = buf_dir[pos + 0x0E]; filesize <<= 8;
		filesize += buf_dir[pos + 0x0D]; filesize <<= 8;
		filesize += buf_dir[pos + 0x0C];

		if( extract )
		{
			printf( "%03d %-12s %08X-%08X (%d)\n",
				filecount,
				filename,
				filepos,
				filepos + filesize,
				filesize
			);

			out = fopen( filename, "wb" );
			fwrite( &buf_data[filepos], filesize, 1, out );
			fclose( out );

		}

		filepos += filesize;
		filecount++;
		pos += 0x10;
	}

	printf( "\n" );
	printf( "complete.\n" );

	free( buf_data );
	free( buf_dir );

	return 0;
}
